/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MEDS                                                     */
/* Tabela : MEDSOLI                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MEDS'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MEDS
GO

CREATE TRIGGER DTULTATU_MEDS
ON MEDSOLI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MEDSOLI', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';'+
                                            'CDPRODUTO='+ CDPRODUTO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MEDSOLI
      SET DTULTATUMEDS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(MEDSOLI.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(MEDSOLI.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(MEDSOLI.VRPERCMEDSOL,0) = ISNULL(INSERTED.VRPERCMEDSOL,0));
   END;
END;
GO

